variables:
  HELM_SECRETS_DRIVER: envsubst

stages: [build, deploy]

build:
  stage: build
  image: docker:stable
  variables:
    LATEST_REF_IMAGE: $CI_REGISTRY_IMAGE:latest
  services:
    - docker:20.10.5-dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
  script:
    - docker build --tag "$LATEST_REF_IMAGE" .
    - docker push "$LATEST_REF_IMAGE"
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      changes: [Dockerfile]

deploy:
  stage: deploy
  image: $CI_REGISTRY_IMAGE:latest
  environment:
    name: production
  script:
    - kubectl config use-context "$KUBE_CONTEXT"
    - gl-ensure-namespace gitlab-managed-apps
    - gl-helmfile --file helmfile.yaml apply --suppress-secrets
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  needs:
     - job: build
       optional: true
